package ME::VFS::RootNode;

use strict;
use warnings;

use base qw(ME::VFS::DirNode);

sub new {
  my $class = shift;
  my $VFS = shift;
  return bless { NodeId => 1, VFS => $VFS, Data => {}, }, ref($class) || $class;
}

sub Create {
  die "No creating the root node";
}

sub Delete {
  die "No deleting the root node";
}

sub UnDelete {
  die "No undeleting the root node";
}

sub ParentNodeId {
  my $Self = shift;
  # loop!
  return $Self->NodeId();
}

# ACL stuff

sub AddACL {
  die "No changing ACLs on the root node";
}

sub DelACL {
  die "No changing ACLs on the root node";
}

sub MoveTo {
  die "No moving the root node"
}

sub CopyTo {
  die "No copying the root node";
}

# some trivial iterator endpoints
sub Path { '/'; }
sub Depth { 0; }
sub HasAncestor { 0; }
sub IsRootNode { 1; }
sub Exists { 1; }
sub IsQuotaNode { 0; }
sub QuotaNode { undef; }
sub ACLs { {}; }
sub HasACL { 0; }

sub PathRelativeTo {
  my $Self = shift;
  my $RelNode = shift;
  die "Relative node " . $RelNode->Path() . " is not an ancestor of self " . $Self->Path();
}

1;
